=== buildroot/quiltpc/build-audio-usb.patch/Makefile ===
# SPDX-License-Identifier: GPL-2.0
# Makefile for the Linux sound card driver
#

KBUILD_CFLAGS += -I$(src)/include

obj-$(CONFIG_SND) += soundwire/ pci/ hda/ soc/ regmap/ core/
