=== buildroot/quiltpc/build-regmap.patch/Makefile ===
# SPDX-License-Identifier: GPL-2.0
# Makefile for the Linux sound card driver
#

KBUILD_CFLAGS += -I$(src)/include

obj-$(CONFIG_SND) += pci/ hda/ soc/
