=== src/soundwire-1.2.2/pci/Makefile ===
# SPDX-License-Identifier: GPL-2.0
#
# Makefile for ALSA
# Copyright (c) 2001 by Jaroslav Kysela <perex@perex.cz>
#


obj-$(CONFIG_SND) += \
	hda/
