=== debian/changelog ===
soundwire-dkms (1.2.2) bionic; urgency=medium

  * fix build erro on ubuntu 5.4 kernel

 -- Hui Wang <hui.wang@canonical.com>  Tue, 07 Jul 2020 20:46:00 +0800

soundwire-dkms (1.2.1) bionic; urgency=medium

  * replace a patch to fix pcm set_param error

 -- Hui Wang <hui.wang@canonical.com>  Wed, 01 Apr 2020 18:01:47 +0800

soundwire-dkms (1.2.0) bionic; urgency=medium

  * based on sof-dev (ww14 commit:a272777)

 -- Hui Wang <hui.wang@canonical.com>  Mon, 01 Apr 2020 09:10:20 +0800
