=== debian/control ===
Source: soundwire-dkms
Section: devel
Priority: extra
Maintainer: Hui Wang <hui.wang@canonical.com>
Standards-Version: 3.8.1
Build-Depends: dkms, python, quilt, debhelper (>= 5), lsb-release, dh-modaliases, linux-headers-oem-osp1
Homepage: https://code.launchpad.net/~ubuntu-audio-dev

Package: soundwire-dkms
Architecture: all
Depends: dkms (>= 1.95), ${misc:Depends}
Description: soundwire audio driver in DKMS format.
XB-Modaliases: ${modaliases}
